searchNodes=[{"doc":"A thin RingCentral API wrapper in Elixir.","ref":"RingCentral.html","title":"RingCentral","type":"module"},{"doc":"Build the RingCentral client, used by functions in both RingCentral.OAuth and RingCentral.APIOptionsserver_url: Optional, the API server URL, default to the value of RingCentral.production_server_url/0client_id: Required, the client IDclient_secret: Required, the client Secrettoken_info: Required if used by RingCentral.API to make API calls, should be set to the result of RingCentral.OAuth.get_token/2http_client: Optional, the module used to make HTTP calls, default to RingCentral.HTTPClient.DefaultClientjson_coder: Optional, the module used as JSON encoder &amp; decoder, default to RingCentral.JSON.DefaultCoder","ref":"RingCentral.html#build/1","title":"RingCentral.build/1","type":"function"},{"doc":"Returns the production API server URL: https://platform.ringcentral.com","ref":"RingCentral.html#production_server_url/0","title":"RingCentral.production_server_url/0","type":"function"},{"doc":"Returns the sandbox API server URL: https://platform.devtest.ringcentral.com","ref":"RingCentral.html#sandbox_server_url/0","title":"RingCentral.sandbox_server_url/0","type":"function"},{"doc":"","ref":"RingCentral.html#t:t/0","title":"RingCentral.t/0","type":"type"},{"doc":"The struct representing the error from the API.","ref":"RingCentral.Error.html","title":"RingCentral.Error","type":"module"},{"doc":"","ref":"RingCentral.Error.html#t:client_error/0","title":"RingCentral.Error.client_error/0","type":"type"},{"doc":"","ref":"RingCentral.Error.html#t:server_error/0","title":"RingCentral.Error.server_error/0","type":"type"},{"doc":"","ref":"RingCentral.Error.html#t:t/0","title":"RingCentral.Error.t/0","type":"type"},{"doc":"The struct representing the response from API.","ref":"RingCentral.Response.html","title":"RingCentral.Response","type":"module"},{"doc":"","ref":"RingCentral.Response.html#t:t/0","title":"RingCentral.Response.t/0","type":"type"},{"doc":"HTTPClient behaviour for RingCentralBuild your own HTTP client:defmodule MyApp.AwesomeHTTPClient do @behaviour RingCentral.HTTPClient @impl true def request(method, url, body, headers \\ []) do if success {:ok, %Response{ status: response.status, headers: response.headers, body: response.body, data: nil }} else {:error, error} -&gt; {:error, %Error{ code: :server_error, detail: error } } end end endThen Use the custom HTTP while building the client:ringcentral = RingCentral.build( client_id: &quot;my-client-id&quot;, client_secret: &quot;my-client-secret&quot;, http_client: MyApp.AwesomeHTTPClient )See RingCentral.HTTPClient.DefaultClient for a reference implementation.","ref":"RingCentral.HTTPClient.html","title":"RingCentral.HTTPClient","type":"behaviour"},{"doc":"","ref":"RingCentral.HTTPClient.html#c:request/4","title":"RingCentral.HTTPClient.request/4","type":"callback"},{"doc":"","ref":"RingCentral.HTTPClient.html#t:http_headers/0","title":"RingCentral.HTTPClient.http_headers/0","type":"type"},{"doc":"","ref":"RingCentral.HTTPClient.html#t:http_method/0","title":"RingCentral.HTTPClient.http_method/0","type":"type"},{"doc":"The default implementation for RingCentral.HTTPClient. Uses Finch as the HTTP client.Add the RingCentral.HTTPClient.DefaultClient to your application's supervision tree:# lib/your_app/application.ex def start(_type, _args) do children = [ ... {RingCentral.HTTPClient.DefaultClient, []} ] ... endOr start it dynamically with start_link/1","ref":"RingCentral.HTTPClient.DefaultClient.html","title":"RingCentral.HTTPClient.DefaultClient","type":"module"},{"doc":"Start an instance of the defalut HTTPClient.The following options will be passed to the Finch.start_link/1:[ name: __MODULE__ pools: %{ RingCentral.sandbox_server_url() =&gt; [size: 1], RingCentral.production_server_url() =&gt; [size: 10] } ]You override the default options with opts, see Finch.start_link/1 for detail.Exampleopts = [ pools: %{ RingCentral.production_server_url() =&gt; [size: 30] } ] RingCentral.HTTPClient.DefaultClient.start_link(opts)","ref":"RingCentral.HTTPClient.DefaultClient.html#start_link/1","title":"RingCentral.HTTPClient.DefaultClient.start_link/1","type":"function"},{"doc":"JSON behaviour for RingCentralBuild your own JSON encoder &amp; decoder:defmodule MyApp.AwesomeJSONCoder do @behaviour RingCentral.JSON @impl true def decode!(json_string) do Jason.decode!(json_string) end @impl true def encode!(data) do Jason.encode!(data) end endThen Use the custom JSON implementation while building the client:ringcentral = RingCentral.build( client_id: &quot;my-client-id&quot;, client_secret: &quot;my-client-secret&quot;, http_client: MyApp.AwesomeHTTPClient json_coder: MyApp.AwesomeJSONCoder )See RingCentral.JSON.DefaultCoder for a reference implementation.","ref":"RingCentral.JSON.html","title":"RingCentral.JSON","type":"behaviour"},{"doc":"","ref":"RingCentral.JSON.html#c:decode!/1","title":"RingCentral.JSON.decode!/1","type":"callback"},{"doc":"","ref":"RingCentral.JSON.html#c:encode!/1","title":"RingCentral.JSON.encode!/1","type":"callback"},{"doc":"The default implementation for RingCentral.JSON. Uses Jason as the JSON encoder &amp; decoder.","ref":"RingCentral.JSON.DefaultCoder.html","title":"RingCentral.JSON.DefaultCoder","type":"module"},{"doc":"The main module for the Authorization flow","ref":"RingCentral.OAuth.html","title":"RingCentral.OAuth","type":"module"},{"doc":"Get the URL for initializing the OAuth 2.0 authorizaiton flow.params is a map contains the options described in the official documentationExampleringcentral = %RingCentral{ client_id: &quot;the-client-id&quot;, client_secret: &quot;the-client-secret&quot;, http_client: RingCentral.HTTPClient.DefaultClient, server_url: &quot;https://platform.ringcentral.com&quot;, token_info: nil } {:ok, authorization_url} = RingCentral.OAuth.authorize(ringcentral, %{ response_type: &quot;code&quot;, redirect_uri: &quot;https://ringcentral-elixir.test&quot; }) # {:ok, &quot;https://service.ringcentral.com/...&quot;}","ref":"RingCentral.OAuth.html#authorize/2","title":"RingCentral.OAuth.authorize/2","type":"function"},{"doc":"Get the access token and refresh token.params is a map contains the options described in the official documentationExampleringcentral = %RingCentral{ client_id: &quot;the-client-id&quot;, client_secret: &quot;the-client-secret&quot;, http_client: RingCentral.HTTPClient.DefaultClient, server_url: &quot;https://platform.ringcentral.com&quot;, token_info: nil } {:ok, token_info} = RingCentral.OAuth.get_token(ringcentral, %{ grant_type: &quot;authorization_code&quot;, code: &quot;U0pDMDFQMDRQQVMwMnxBQUFGTVUyYURGYi0wUEhEZ2VLeGFiamFvZlNMQlZ5TExBUHBlZVpTSVlhWk&quot;, redirect_uri: &quot;https://ringcentral-elixir.test&quot; }) # {:ok, %{&quot;access_token&quot;: &quot;...&quot;, &quot;token_type&quot;: &quot;bearer&quot;, &quot;refresh_token&quot;: &quot;...&quot;}}","ref":"RingCentral.OAuth.html#get_token/2","title":"RingCentral.OAuth.get_token/2","type":"function"},{"doc":"Revokes access/refresh token.token is the active access or refresh token to be revoked, see the official documentation for more information.Exampleringcentral = %RingCentral{ client_id: &quot;the-client-id&quot;, client_secret: &quot;the-client-secret&quot;, http_client: RingCentral.HTTPClient.DefaultClient, server_url: &quot;https://platform.ringcentral.com&quot;, token_info: nil } RingCentral.OAuth.revoke_token(ringcentral, &quot;U0pDMDFQMDFKV1MwMXwJ_W7L1fG4eGXBW9Pp-otywzriCw&quot;) # :ok","ref":"RingCentral.OAuth.html#revoke_token/2","title":"RingCentral.OAuth.revoke_token/2","type":"function"},{"doc":"The Main module to interact with RingCentral REST APIs.","ref":"RingCentral.API.html","title":"RingCentral.API","type":"module"},{"doc":"Send a DELETE request to the REST API.It will uses ringcentral.http_client to send the request to RingCentral API, which by default is the RingCentral.HTTPClient.DefaultClient.","ref":"RingCentral.API.html#delete/3","title":"RingCentral.API.delete/3","type":"function"},{"doc":"Send a GET request to the REST API.It will uses ringcentral.http_client to send the request to RingCentral API, which by default is the RingCentral.HTTPClient.DefaultClient.","ref":"RingCentral.API.html#get/3","title":"RingCentral.API.get/3","type":"function"},{"doc":"Send a POST request to the REST API.It will uses ringcentral.http_client to send the request to RingCentral API, which by default is the RingCentral.HTTPClient.DefaultClient.","ref":"RingCentral.API.html#post/4","title":"RingCentral.API.post/4","type":"function"},{"doc":"Send a PUT request to the REST API.It will uses ringcentral.http_client to send the request to RingCentral API, which by default is the RingCentral.HTTPClient.DefaultClient.","ref":"RingCentral.API.html#put/4","title":"RingCentral.API.put/4","type":"function"},{"doc":"Guide","ref":"guide.html","title":"Guide","type":"extras"},{"doc":"Add the default HTTP client RingCentral.HTTPClient.DefaultClient to the supervision tree:# lib/your_app/application.ex def start(_type, _args) do children = [ ... {RingCentral.HTTPClient.DefaultClient, []} ] ... endBuild the RingCentral Clientringcentral = RingCentral.build( client_id: &quot;the-client-id&quot;, client_secret: &quot;the-client-secret&quot;, server_url: RingCentral.production_server_url() ) # %RingCentral{ # client_id: &quot;the-client-id&quot;, # client_secret: &quot;the-client-secret&quot;, # http_client: RingCentral.HTTPClient.DefaultClient, # server_url: &quot;https://platform.ringcentral.com&quot;, # token_info: nil #}Initial the OAuth flow{:ok, authorization_url} = RingCentral.OAuth.authorize(ringcentral, %{ response_type: &quot;code&quot;, redirect_uri: &quot;https://ringcentral-elixir.test&quot; }) # {:ok, &quot;https://service.ringcentral.com/...&quot;}Exchange the code for token{:ok, token_info} = RingCentral.OAuth.get_token(ringcentral, %{ grant_type: &quot;authorization_code&quot;, code: &quot;U0pDMDFQMDRQQVMwMnxBQUFGTVUyYURGYi0wUEhEZ2VLeGFiamFvZlNMQlZ5TExBUHBlZVpTSVlhWk&quot;, redirect_uri: &quot;https://ringcentral-elixir.test&quot; }) # {:ok, %{&quot;access_token&quot;: &quot;...&quot;, &quot;token_type&quot;: &quot;bearer&quot;, &quot;refresh_token&quot;: &quot;...&quot;}}Update client with the token_inforingcentral_with_token_info = RingCentral.build( client_id: &quot;the-client-id&quot;, client_secret: &quot;the-client-secret&quot;, server_url: RingCentral.production_server_url(), token_info: token_info )Then you can call the REST API with RingCentral.API module:{:ok, response} = RingCentral.API.get(ringcentral_with_token_info, &quot;/&quot;) # {:ok, # %RingCentral.Response{ # body: &quot;{\\n \\&quot;uri\\&quot; : \\&quot;https://platform.ringcentral.com/restapi/v1.0/\\&quot;,\\n \\&quot;versionString\\&quot; : \\&quot;1.0.45\\&quot;,\\n \\&quot;releaseDate\\&quot; : \\&quot;2021-02-12T00:00:00.000Z\\&quot;,\\n \\&quot;uriString\\&quot; : \\&quot;v1.0\\&quot;\\n}&quot;, # data: %{ # &quot;releaseDate&quot; =&gt; &quot;2021-02-12T00:00:00.000Z&quot;, # &quot;uri&quot; =&gt; &quot;https://platform.ringcentral.com/restapi/v1.0/&quot;, # &quot;uriString&quot; =&gt; &quot;v1.0&quot;, # &quot;versionString&quot; =&gt; &quot;1.0.45&quot; # }, # headers: [ # {&quot;server&quot;, &quot;nginx&quot;}, # {&quot;date&quot;, &quot;Sun, 28 Mar 2021 05:34:01 GMT&quot;}, # {&quot;content-type&quot;, &quot;application/json;charset=utf-8&quot;}, # {&quot;content-length&quot;, &quot;162&quot;}, # {&quot;connection&quot;, &quot;keep-alive&quot;}, # {&quot;rcrequestid&quot;, &quot;33baa9e6-8f87-11eb-be5a-005056b5eaad&quot;}, # {&quot;routingkey&quot;, &quot;AMS01P35PAS01&quot;}, # {&quot;content-language&quot;, &quot;en&quot;}, # {&quot;vary&quot;, &quot;Accept-Encoding, User-Agent&quot;} # ], # status: 200 # }}","ref":"guide.html#usage","title":"Guide - Usage","type":"extras"},{"doc":"Using a custom HTTP ClientBy default, the RingCentral.HTTPClient.DefaultClient will be used as the HTTP client.But if you need, you can build a customized HTTP Client by implement the RingCentral.HTTPClient behaviour.defmodule MyApp.AwesomeHTTPClient do @behaviour RingCentral.HTTPClient @impl true def request(method, url, body, headers \\\\ []) do if success {:ok, %Response{ status: response.status, headers: response.headers, body: response.body, data: nil }} else {:error, error} -&gt; {:error, %Error{ code: :server_error, detail: error } } end end endThen Use the custom HTTP while building the client:ringcentral = RingCentral.build( client_id: &quot;my-client-id&quot;, client_secret: &quot;my-client-secret&quot;, http_client: MyApp.AwesomeHTTPClient )","ref":"custom_http_client.html","title":"Using a custom HTTP Client","type":"extras"}]